 /***************************************************************************
  Research Academic Computer Technology Institute,
  61 Riga Feraiou Str,26221 Patras ,Greece &
  Department of Computer Engineering and Informatics,
  University of Patras, 26500 Rion ,Patras,Greece

  Research Unit 6

  project name:Bandwidth Broker
  project team:Christos Bouras
               Dimitris Primpas
	       Kostas Stamos
	       Ioannis Pappas

  date:20 January 2005
  updated:no
  contact:bouras@cti.gr,primpas@cti.gr,stamos@cti.gr,pappasj@ceid.upatras.gr

*****************************************************************************/



/* Headers */

/* add this header as a header of ns  */
#ifndef ns_BBagent_h
#define ns_BBagent_h

#include "agent.h"
#include "tclcl.h"
#include "packet.h"
#include "address.h"
#include "ip.h"
#include "route.h"
#include "node.h"

#include <iostream>
#include <list.h>
using namespace std;


/*****************************************************************
  struct name: neighbour
  mission:keeps the availiable bandwith(bwdth) about the line that
          connects a specific agent with his neighbour agent with
	  node id == n_id
*****************************************************************/
typedef struct neighbour
{
    int n_id;   /*node id of the neighbour*/
    int* bwdth;  /*availiable bandwith at time 0-1 , element bwdth[0]*/
		  /*availiable bandwith at time 1-2 , element bwdth[1]*/

  /* constructors */
   neighbour(int nn_id,int nbwdth,int nstart_time,int nstop_time)
   {
    n_id=nn_id;
    bwdth= new int[nstop_time];
    int i;
    for(i=0;i<nstop_time;i++)
    {
      bwdth[i]=nbwdth;
    }

   }


  /* operators overloading */
    neighbour &operator=(const neighbour &nghbr)
    {
     this->n_id = nghbr.n_id;
     this->bwdth = nghbr.bwdth;
     return *this;
    }

    int operator==(const neighbour &nghbr) const
    {
     if(this->n_id != nghbr.n_id ) return 0;
     if(this->bwdth  != nghbr.bwdth  ) return 0;
     return 1;
    }

};




/********************************************************************************
 class name:BBagent
 mission: An instance(object) of this class keeps all the information(properties)
          for a BB agent of our domain.This instance is a part of a list
	  of BBagent instances.This list is a member of the class
	  BBagent_Participants.An instance(object) of the latter class takes the
	  role of a database which a BBbase agent asks and informs about
	  every change of the existed situation of our domain.
*********************************************************************************/
class BBagent
{


public:
        /* constructors */
        /* constructor (node_id,list<neighbour> nghbr_list) einai gia ton BBbase/Central */
	BBagent(nsaddr_t,list<neighbour>,int);

	/* constructor(node_id) einai gia ton BBbase/Distributed */
	BBagent(nsaddr_t);

        /*destructor*/
	~BBagent(){}

	/*operators overloading*/
	BBagent &operator=(const BBagent &bbgnt);
	int operator==(const BBagent &bbgnt) const;


	/* access functions */
	nsaddr_t GetNode_id()const;
	void SetNode_id(nsaddr_t);
	int GetStatus() const ;
	void SetStatus(int);
	int GetN_nghbr() const ;
	void SetN_nghbr(int);
	void Set_nghbr_list(list<neighbour>);
	void Fix_nghbr(int,int,int,int);//(n_id,bdw,start_time,stop_time)
	int  Ask_bwd(int,int,int,int);//(n_id,bdw,start_time,stop_time)
	void ShowBBagent();
	int Query_bwd_available(int,int);//(n_id,time)

protected:

    nsaddr_t node_id;   /* the node where the BBagent is */
    int status;   /* BBagent is up or down */
    int n_nghbr; /*how many nodes BBagent controls */

    list<neighbour> nghbr_list; /* list of structs 'neighbour' */
};







#endif // ns_BBagent_h
