/***************************************************************************
  Research Academic Computer Technology Institute,
  61 Riga Feraiou Str,26221 Patras ,Greece &
  Department of Computer Engineering and Informatics,
  University of Patras, 26500 Rion ,Patras,Greece

  Research Unit 6

  project name:Bandwidth Broker
  project team:Christos Bouras
               Dimitris Primpas
	       Kostas Stamos
	       Ioannis Pappas

  date:20 January 2005
  updated:no
  contact:bouras@cti.gr,primpas@cti.gr,stamos@cti.gr,pappasj@ceid.upatras.gr

*****************************************************************************/

/* Headers */

/* add this header as a header of ns  */
#ifndef ns_CentralAacrBBbase_h
#define ns_CentralAacrBBbase_h

#include "agent.h"
#include "tclcl.h"
#include "packet.h"
#include "address.h"
#include "ip.h"
#include "route.h"
#include "node.h"

#include "BBbase.h"
#include <list.h>
#include <vector.h>



///////////////////////////////////////////////////////////////////////////////////
//Added by Enrique Peña
class CentralAacrBBbaseAgent;


class RequestsTimer : public TimerHandler {
public:
	RequestsTimer(CentralAacrBBbaseAgent *a) : TimerHandler() { a_ = a; }
protected:
	virtual void expire(Event *e);
	CentralAacrBBbaseAgent *a_;
};
////////////////////////////////////////////////////////////////////////////////////


/*****************************************************
 class name:CentralAacrBBbaseAgent
 mission:creates a new Agent which handles requests
 	 for bandwith in the domain in which he is
	 responsible
******************************************************/
class CentralAacrBBbaseAgent : public BBbaseAgent {
public:
	/*constructor*/
	CentralAacrBBbaseAgent();

	/*class functions*/
	virtual int command(int argc, const char*const* argv);
    virtual void recv(Packet*, Handler*);

protected:

	vector<Request> rArray; // Keeps the requests that will be examined together (R set)
	List_Requests wqArray;   // Keeps the rest of the requests (Wq)
	                                   // (normally Wq is a superset of R, but here this list contains only requests not in R)
	int Rsize;	// The size of the R set

	// Keep global statistics
	int count_requests_valid_nonzero;	// Count valid requests
	int count_requests_zero;	// Count requests for 0 bwd
	int count_requests_invalid;	// Count invalid requests
	int count_accepted;	// Count acepted requests
	int count_profit;	// Count total profit from accepted requests
	int count_answer_time;	// Count the total of time all requests have waited for answer
	int count_LPsize;	// Count the total of all rSizes
	int count_LPproblems;	// Count the number of times the LP solution was invoked

	// Additional for AAC/AACR algorithms
	int threshold;
	float a;

	// Additional for AACR
	int resubmit_probability;	// A number 0..100 (the probability percentage to be resubmitted)
	List_Requests resubmittedArray;
	int count_resubmitted;

	//Added by Enrique Peña
	RequestsTimer request_timer;
	int request_timeout;
	void solve_LP();

};

#endif // ns_CentralAacrBBbase_h












