/***************************************************************************
  Research Academic Computer Technology Institute,
  61 Riga Feraiou Str,26221 Patras ,Greece &
  Department of Computer Engineering and Informatics,
  University of Patras, 26500 Rion ,Patras,Greece

  Research Unit 6

  project name:Bandwidth Broker
  project team:Christos Bouras
               Dimitris Primpas
	       Kostas Stamos
	       Ioannis Pappas

  date:20 January 2005
  updated:no
  contact:bouras@cti.gr,primpas@cti.gr,stamos@cti.gr,pappasj@ceid.upatras.gr

*****************************************************************************/

/* Headers */

/* add this header as a header of ns  */
#ifndef ns_Request_h
#define ns_Request_h

#include "agent.h"
#include "tclcl.h"
#include "packet.h"
#include "address.h"
#include "ip.h"
#include "route.h"
#include "node.h"
#include <list.h>


/********************************************************************************
 class name:Request
 mission:An instance(object) of this class keeps all the information(properties)
          of a request for bandwidth done by BB agent of our domain.This
	  instance is a part of a list which consists of Request instances.This
	  list is a member of the class List_Requests.An instance(object) of the
	  latter class takes the role of a database which a BBbase agent asks and
	  informs about every change of the status of the existed requests for
	   bandwidth ,in our domain.
*********************************************************************************/
class Request
{
public:
 	/* constructor */
	Request(nsaddr_t,nsaddr_t ,int ,double ,double);

 	/* constructor */
	Request(nsaddr_t,nsaddr_t ,int ,double ,double, double);

	/* destructor */
	~Request(){}

	//operators overloading
	Request &operator=(const Request &rqst);
	int operator==(const Request &rqst) const;

	/* access functions */
	nsaddr_t GetSender() const ;
	void SetSender(nsaddr_t);
	nsaddr_t GetEndnode() const ;
	void SetEndnode(nsaddr_t);
 	int GetBndw_request() const ;
	void SetBndw_request(int);
	double GetStart_time() const ;
	void SetStart_time(double);
	double GetStop_time() const ;
	void SetStop_time(double);
	int GetStatus() const ;
	void SetStatus(int);
	double GetArrival_time() const ;
	void SetArrival_time(double);
	double GetAnswer_time() const ;
	void SetAnswer_time(double);
	void ShowRequest();         /*shows all the elements of a request*/

protected:



    nsaddr_t sender;  /*address of the node(sender) who sends the request for bandwidth */
    nsaddr_t endnode; /*address of the last node of the request */
    int bndw_request;  /*the magnitude of the bandwidth */

    double start_time; /*when the allocation of the bandwith begins */
    double stop_time; /*when the allocation of the bandwith ends */

    int status;   /*the status of the request is pending,satisfied or rejected*/

	double arrival_time;	// when the request arrived at BB
	double answer_time;	// when the BB answered the request

};







#endif // ns_Request_h
