/***************************************************************************
  Research Academic Computer Technology Institute,
  61 Riga Feraiou Str,26221 Patras ,Greece &
  Department of Computer Engineering and Informatics,
  University of Patras, 26500 Rion ,Patras,Greece

  Research Unit 6

  project name:Bandwidth Broker
  project team:Christos Bouras
               Dimitris Primpas
	       Kostas Stamos
	       Ioannis Pappas

  date:20 January 2005
  updated:no
  contact:bouras@cti.gr,primpas@cti.gr,stamos@cti.gr,pappasj@ceid.upatras.gr

*****************************************************************************/

/* Headers */
#include "BBagent.h"


/* constants */

/**********************************************
 constants name:DOWN,ACTIVE
 mission:these constants specify the status in
         which a BBagent is
**********************************************/
#define DOWN     0
#define ACTIVE   1



/* constructors */
BBagent::BBagent(nsaddr_t nnode_id,list<neighbour> nnghbr_list,int nstatus)
{
    node_id=nnode_id;
    nghbr_list=nnghbr_list;
    status=nstatus;
   /* cout << "BBagent constructor "<<endl; */
}

BBagent::BBagent(nsaddr_t nnode_id) : node_id(nnode_id),status(ACTIVE)
{
   /*cout << "BBagent constructor "<<endl; */
}



/* operators overloading */
BBagent& BBagent::operator=(const BBagent &bbgnt)
{
   this->node_id = bbgnt.node_id;   /* the node where BBagent is */
   this->status = bbgnt.status;   /* O BBagent einai energos i epese*/
   this->n_nghbr = bbgnt.n_nghbr; /* posous kombous elegxei */
   this->nghbr_list = bbgnt.nghbr_list; /* einai i domi neighbour */
   return *this;
}

 /**************************************************************
   In this overloading i have used comments cause i want to get,
    delete and find the BBagent instance only according to the
    number of the node where he is on
 *************************************************************/
int BBagent::operator==(const BBagent &bbgnt) const
{
  if(this->node_id != bbgnt.node_id ) return 0;
  /* if( this->status != bbgnt.status  ) return 0;*/
  /* if( this->n_nghbr != bbgnt.n_nghbr) return 0;*/
  /* if( this->nghbr_list != bbgnt.nghbr_list) return 0;*/
  return 1;
}


/* access functions  */
nsaddr_t BBagent::GetNode_id()const
{ return node_id; }

void BBagent::SetNode_id(nsaddr_t nnode_id)
{ node_id=nnode_id; }

int BBagent::GetStatus() const
{return status;}

void BBagent::SetStatus(int nstatus)
{ status=nstatus;}

int BBagent::GetN_nghbr() const
{return n_nghbr;}

void BBagent::SetN_nghbr(int nn_nghbr)
{ n_nghbr=nn_nghbr;}


void BBagent::Set_nghbr_list(list<neighbour> nnghbr_list)
{ nghbr_list=nnghbr_list;}



/******************************************************************
 function name: BBagent::Ask_bwd
 return value:int (0 or 1)
 arguments:the node_id of the neighbour of the agent,the bandwidth,
           the start and the stop time of the request
 mission:question if the instance agent that calls this function
         has the bandwidth bwd availiable between this agent and
	 the agent with node id n_id.If the availiable bandwidth
	 for the connection is less(<) than the bwd the answer is
	 negative and the return value is 1.Else the answer is
	 positive and the return value is 0.
*******************************************************************/
int  BBagent::Ask_bwd(int n_id,int bwd,int start_time,int stop_time)
{
     list<neighbour>::const_iterator i;/* an iterator for finding the neighbour n_id */

     for(i=nghbr_list.begin();i!=nghbr_list.end();i++)
     {
                if (i->n_id==n_id)
                {
		  int j;
		  for(j=start_time;j<stop_time;j++)
		  {
		     if(i->bwdth[j]<bwd)/*if the availiable bandwidth is less than the requested*/
		     {
                        /*if the availiable bandwidth of the line is less than the bwd
	                the answer is negative and the return value is 1 */
      	                return 1;
		     }
		  }
		  /*else positive answer*/
                  return 0;
		}
     }
return 0;
}


/***********************************************************************
 function name: BBagent::Fix_nghbr
 return value:void
 arguments:the node_id of the neighbour of the agent,the bandwidth,
           the start and the stop time of the request
 mission:for the specific agent ,remove the bandwith bwd from the
         bandwidth of the connection with the neighbour agent
	 with node id == n_id
************************************************************************/
void BBagent::Fix_nghbr(int n_id,int bwd,int start_time,int stop_time)
{
       list<neighbour>::iterator i;
        for(i=nghbr_list.begin();i!=nghbr_list.end();i++)
        {
            if (i->n_id==n_id)
	    {
               int j;
		  for(j=start_time;j<stop_time;j++)
		  {
		     i->bwdth[j]=i->bwdth[j] - bwd;
		  }
		 break;
	    }
        }

}


/***********************************************************************\
 function name: BBagent::ShowBBagent
 return value:void
 arguments:none
 mission:shows the node id of the BBagent and its status
*************************************************************************/
void BBagent::ShowBBagent()
{
 cout<<"BBagent is on "<< node_id <<" node"<<endl;
 cout<<"its status is "<< status  <<endl;
 /*cout<<"and has under its commands  "<< n_nghbr <<"neighbours"<<endl; */
 

}
