/***************************************************************************
  Research Academic Computer Technology Institute,
  61 Riga Feraiou Str,26221 Patras ,Greece &
  Department of Computer Engineering and Informatics,
  University of Patras, 26500 Rion ,Patras,Greece

  Research Unit 6

  project name:Bandwidth Broker
  project team:Christos Bouras
               Dimitris Primpas
	       Kostas Stamos
	       Ioannis Pappas

  date:20 January 2005
  updated:no
  contact:bouras@cti.gr,primpas@cti.gr,stamos@cti.gr,pappasj@ceid.upatras.gr

*****************************************************************************/

/*Headers*/
#include "CentralBBbase.h"
#include <iostream.h>

/*constants*/
/*******************************************
 constants name:REQUEST,ANSWER,FIX_BWD
 		UNAVAILIABLE,DISTR_QUESTION,
		DISTR_ANSWER,CENTR_QUESTION,
		CENTR_ANSWER
mission:these constants specify the
	type of a packet
*******************************************/
#define REQUEST        0/*request packet from BBedge to BBbase for bandwidth */
#define ANSWER         1/*answer packet */
#define FIX_BWD        2/*command packet to BBedge to fix his bwd*/
#define UNAVAILABLE    3/*information packet to BBedge that BBbase is unavailiable now*/
#define DISTR_QUESTION 4 /*question packet from DistributedBBbase to BBedge if edge has bwd*/
#define DISTR_ANSWER   5 /*answer to  DistributedBBbase if BBedge has bwd*/
#define CENTR_QUESTION 6 /* question packet from CentralBBbase of what  BBedge controls */
#define CENTR_ANSWER   7 /*answer to CentralBBbase of what  BBedge controls*/


#define NEGATIVE 0
#define POSITIVE 1

/**********************************************
 constants name:DOWN,ACTIVE
 mission:these constants specify the status in
         which a BBagent is
**********************************************/
#define DOWN     0
#define ACTIVE   1

/*******************************************
 constants name:PENDING,SATISFIED,
 		REJECTED,EXPIRED
mission:these constants specify the
	status in which a request is
*******************************************/
#define PENDING     0
#define SATISFIED   1
#define REJECTED    2
#define EXPIRED     3



static class CentralBBbaseClass : public TclClass {
public:
	CentralBBbaseClass() : TclClass("Agent/BBbase/Central") {}
	TclObject* create(int, const char*const*) {
		return (new CentralBBbaseAgent());
	}
} class_CentralBBbase;


/*constructor*/
CentralBBbaseAgent::CentralBBbaseAgent() 
{
    bind("packetSize_", &size_);
    available = TRUE;/* at the beginning,BBbase is availiable*/
    cur_dscp=2;
    list_request= new List_Requests;/* object which handles the request list*/
    list_request_buffer= new List_Requests; /*FUTURE USE*/ /* object which handles the request buffer list*/
    bbgnt_particip=new BBagent_Participants;/* object which handles the BBAgents list*/
    max_request_buffer=0;/*FUTURE USE*/ /*if the user does not set the magnidute of the buffer, then the default is 0 */
    enable_fault_tolerance=0;/*iniatially Central Agent is not fault tolerant,becomes fault tolerant only if the user */
					/*enables that characteristic*/
}


/************************************************
 function name: CentralBBbaseAgent::command
 return value:int
 arguments:number of tcl command arguments,
 	   the command arguments
 mission:takes the tcl commands and transforms
         them to c++ functions & operations
*************************************************/
int CentralBBbaseAgent::command(int argc, const char*const* argv)
{
   if (argc == 2)/*if we have two(2) arguments*/
   {
      /*******************************************
       if the tcl command is enable_fault_tolerance,
       then the user enables the fault tolerant
       characteristic of the Central Agent
      *******************************************/
      if (strcmp(argv[1], "enable_fault_tolerance") == 0)
        {
	  enable_fault_tolerance=1;
          return (TCL_OK);
	}
   }

   if (argc == 3)/*if we have three(3) arguments*/
   {
      /*******************************************
       FUTURE USE
       if the tcl command is set_request_buffer,
       then the user sets the max magnitude of
       the buffer which keeps all the requests
        that cannot now be examined
      *******************************************/
      if (strcmp(argv[1], "set_request_buffer") == 0)
        {
          max_request_buffer=atoi(argv[2]);
          return (TCL_OK);
	}
   }

   return (Agent::command(argc, argv));
}


/***********************************************
 function name: CentralBBbaseAgent::recv
 return value:void
 arguments:a packet , a handler
 mission:receives and handles the packets of
         the CentralBBbaseAgent
************************************************/
void CentralBBbaseAgent::recv(Packet* pkt, Handler*)
{
    /* Access the IP header for the received packet*/
    hdr_ip* hdrip = hdr_ip::access(pkt);
    /* Access the bbe header for the received packet*/
    hdr_bbe* hdr = hdr_bbe::access(pkt);

    /*******************************************
     create an instance of the request in which
     the request packet refers to
   ********************************************/
   Request pck_request(hdr->sender,hdr->endnode,hdr->bndw_request,hdr->start_time,hdr->stop_time);



    /*****************************************
     if the type of the packet is REQUEST
    ******************************************/
    if (hdr->type == REQUEST)
    {
        /******************************************
	 IF this is the first bwd request packet a
	 BBedge sends(hop_num==1) but the BBbase
	 is unavailiable ,send back to BBedge this
	 information
	*******************************************/
        if (hdr->hop_num==1 && available==FALSE)
        {
            dst_.addr_ = hdr->sender;/*set the destination address of the packet*/
	    /****************************
	    allocate & send a new packet
	    *****************************/
            Packet* next_pkt = allocpkt();
            hdr_ip* ippkt = hdr_ip::access(next_pkt);
            ippkt->DSCP_=1;
            hdr_bbb* next_hdr = hdr_bbb::access(next_pkt);
            next_hdr->type = UNAVAILABLE;
            next_hdr->endnode = hdr->endnode;
            send(next_pkt,0);
        }
        /*******************************************
	 ELSE
	********************************************/
        else
        {

	    /*we find the current time of the expirement*/
	    Tcl& tcl= Tcl::instance();
            tcl.evalc("set now [$ns now]");
	    char *nh = tcl.result();
            cout<<"the time now is "<<atoi(nh)<<"\n";

	   /*********************************
	   IF the pck_request is still valid
	   **********************************/
	   if(atoi(nh) < pck_request.GetStart_time() )
	   {
	    cout<<"o.k. the time of the request is valid"<<"\n";


	    /******************************************
	     IF this is the first bwd request packet a
	     BBedge sends(hop_num==1)
	     BBbase becomes unavailiable
	     create a new record to request database
	     accomplishes the request according to his
	     database
            ******************************************/
            if (hdr->hop_num==1)
            {
                dst_.addr_ = hdr->sender;/*set the destination address of the packet*/

                available=FALSE;/*BBbase unavailiable*/

		Request newrequest(hdr->sender,hdr->endnode,hdr->bndw_request,hdr->start_time,hdr->stop_time);
		list_request->add_to_list(newrequest);/*create a new record to request database*/

		/******************************************************************************
		 FINDING EVERY NODE,
		 WHILE(1)
		 {
		   IF(IS THIS THE LAST NODE? (hop1==hdr->endnode))
		   {
		    POSITIVE ANSWER TO THE REQUEST SENDER
		    FIX DATA BASE & FIX BWD
		    END OF WHILE(BREAK)
		   }
		   ELSE
		   {
		    hop1=neighbour_of_hop1
                    CHECK BWD FOR THE CONNECTION hop1-neighbour_of_hop1
		    IF(AVAILIABLE NODE BWD<REQUEST )
		    {
		     SEND NEGATIVE ANSWER TO THE REQUEST SENDER
                     END OF WHILE(BREAK)
		    }
		   }

		 }
		*******************************************************************************/
	         Tcl& tcl= Tcl::instance();
	         tcl.evalc("$ns compute-routes");
                 tcl.evalc("set rlg [$ns get-routelogic]");

                 char *nh;
                 int hop1 = hdr->sender;

                 while(1)
                {
		        /***************************************
			 IF hop1 is the last node
			 the request can be accomlished.
			 positive answer to the request sender
			 fix bwd
			 update list of requests
			 CentralBBbase availiable
			***************************************/
			if(hop1==hdr->endnode)
			{
                         	/*****************************
		                  positive answer to the
		                  request sender
	  	                ******************************/
				dst_.addr_ = hdr->sender;/*set the destination address of the packet*/
				/****************************
         	                 allocate & send a new packet
	                        *****************************/
				Packet* next_pkt = allocpkt();
				hdr_ip* ippkt = hdr_ip::access(next_pkt);
				ippkt->DSCP_=1;
				hdr_bbb* next_hdr      = hdr_bbb::access(next_pkt);
				next_hdr->answer       = POSITIVE;
				next_hdr->type         = ANSWER;
				next_hdr->sender       = hdr->sender;
				next_hdr->endnode      = hdr->endnode;
				next_hdr->dscp         = cur_dscp;
				next_hdr->bndw_request =hdr->bndw_request;
				next_hdr->start_time   =hdr->start_time;
				next_hdr->stop_time    =hdr->stop_time;
				cur_dscp=cur_dscp+POSITIVE;
				send(next_pkt,0);


				/******************************
				 FIX_BWD
				 *******************************/


				 tcl.evalf("set temp [$rlg lookup %d %d]",(int)hdr->sender,(int)hdr->endnode);
				 char *nh_1 = tcl.result();
				 int hop11 = hdr->sender;
				 int hop22 = atoi(nh_1);
			         while(1)
				 {
					dst_.addr_=hop11;/*set the destination address of the packet*/
					/******************************
				         IF ENABLE_FAULT_TOLERANCE==1
				        *******************************/
				        /****************************
         	                         allocate & send a new packet
	                                *****************************/
					if(enable_fault_tolerance==1)
					{
					 Packet* next_pkt1 = allocpkt();
					 hdr_ip* ippkt1 = hdr_ip::access(next_pkt1);
					 ippkt1->DSCP_=1;
					 hdr_bbb* next_hdr1 = hdr_bbb::access(next_pkt1);
					 next_hdr1->type = FIX_BWD;
					 next_hdr1->bndw_request = hdr->bndw_request;
					 next_hdr1->endnode = hop22;
					 next_hdr1->start_time = hdr->start_time;
					 next_hdr1->stop_time = hdr->stop_time;
					 send(next_pkt1,0);
 					}
					/****************************************
					 update of (database) list of BBagents
					 At BBagent object  removes bwd at
					his connection with n_id
					*****************************************/
					BBagent n1_agent(dst_.addr_);
					bbgnt_particip->agent_remove_bwd(n1_agent,hop22,hdr->bndw_request,hdr->start_time,hdr->stop_time);



					dst_.addr_=hop22;/*set the destination address of the packet*/
					/******************************
				         IF ENABLE_FAULT_TOLERANCE==1
				        *******************************/
					/****************************
         	                         allocate & send a new packet
	                                *****************************/
					if(enable_fault_tolerance==1)
					{
					 Packet* next_pkt2 = allocpkt();
					 hdr_ip* ippkt2 = hdr_ip::access(next_pkt2);
					 ippkt2->DSCP_=1;
					 hdr_bbb* next_hdr2 = hdr_bbb::access(next_pkt2);
					 next_hdr2->type = FIX_BWD;
					 next_hdr2->bndw_request = hdr->bndw_request;
					 next_hdr2->endnode = hop11;
					 next_hdr2->start_time = hdr->start_time;
					 next_hdr2->stop_time = hdr->stop_time;
					 send(next_pkt2,0);
					}

					/****************************************
					 update of (database) list of BBagents
					 At BBagent object  removes bwd at
					his connection with n_id
					*****************************************/
					BBagent n2_agent(dst_.addr_);
					bbgnt_particip->agent_remove_bwd(n2_agent,hop11,hdr->bndw_request,hdr->start_time,hdr->stop_time);



					/************************
			                 if this node(hop22) is
			                 the last one,end the
			                  while loop
			                *************************/
					if (hop22 == hdr->endnode)
					break;

					/*****************************************
     	                                 ELSE find the first node next to hop22
	                                 which is on the path of the bwd request.
			                 and set it as nh_1.
			                 hop22 set as hop11 and the new node(nh_1)
			                 set it as hop22.
			                 In that way,during the next loop the
			                 connection hop11-hop22 is going to be
			                 fixed at both sided with the new bwd
			                ***************************************/
					tcl.evalf("set temp [$rlg lookup %d %d]",hop22,(int)hdr->endnode);
					nh_1 = tcl.result();
					hop11=hop22;
					hop22=atoi(nh_1);

				}/*end of while(1) loop*/

			  /*update the list of Requests*/
               		  Request newrequest(hdr->sender,hdr->endnode,hdr->bndw_request,hdr->start_time,hdr->stop_time);
			  newrequest.SetStatus(SATISFIED);
		 	  list_request->add_to_list(newrequest);

			  available=TRUE;/*the CentralBBbase is now availiable*/
			  break;                 /* get out of  while(1)*/



			}/*end of "if(hop1==hdr->endnode)" case of positive answer from the database */


			/****************************
			 ELSE CHECK BWD
			*****************************/
			else
			{
			   /******************************************
			    create a BBagent object with address hop1
			   *******************************************/
			   dst_.addr_ = hop1;
			   BBagent n_agent(dst_.addr_);

			   /******************************
			    find the neighbour of hop1
			   *******************************/
			   tcl.evalf("set temp [$rlg lookup %d %d]",hop1,(int)hdr->endnode);
			   char *nh_2 = tcl.result();

			   hop1=atoi(nh_2);/*set hop1=neighbour of hop1*/


			    /*********************************************
			    IF list(database) is empty
			    NEGATIVE answer to the request sender
			    update list of requests
			    CentralBBbase is availiable
			   **********************************************/
			   if( bbgnt_particip->GetSize_of_list()==0 )
			   {
 		                /****************************
		                 send negative answer to
		                 the request sender
		                *****************************/
				dst_.addr_ = hdr->sender;/*set the destination address of the packet*/
				/****************************
         	                 allocate & send a new packet
	                        *****************************/
				Packet* next_pkt = allocpkt();
				hdr_ip* ippkt = hdr_ip::access(next_pkt);
				ippkt->DSCP_=1;
				hdr_bbb* next_hdr      = hdr_bbb::access(next_pkt);
				next_hdr->answer       = NEGATIVE;
				next_hdr->type         = ANSWER;
				next_hdr->sender       = hdr->sender;
				next_hdr->endnode      = hdr->endnode;
				next_hdr->dscp         = cur_dscp;
				next_hdr->bndw_request =hdr->bndw_request;
				next_hdr->start_time   =hdr->start_time;
				next_hdr->stop_time    =hdr->stop_time;
				cur_dscp=cur_dscp+NEGATIVE;
				send(next_pkt,0);

			    /*update the list of Requests*/
			    Request newrequest(hdr->sender,hdr->endnode,hdr->bndw_request,hdr->start_time,hdr->stop_time);
		            newrequest.SetStatus(REJECTED);
		            list_request->add_to_list(newrequest);

			    available=TRUE;/*the CentralBBbase is now availiable*/
			    break;/* get out of  while(1)*/

			   }/*end of "if( bbgnt_particip->GetSize_of_list()==0 )" */



			   /***************************************************
			    IF there is no availiable bwd at the particular
			    node(n_agent),agent_ask_bwd returns 1
			    NEGATIVE answer to the request sender
			    update list of request
			    CentralBBbase is availiable
			   ****************************************************/
			   if( bbgnt_particip->agent_ask_bwd(n_agent,hop1,hdr->bndw_request,hdr->start_time,hdr->stop_time)==1 )
			   {
			        /****************************
		                 send negative answer to
		                 the request sender
		                *****************************/
				dst_.addr_ = hdr->sender;/*set the destination address of the packet*/
				/****************************
         	                 allocate & send a new packet
	                        *****************************/
				Packet* next_pkt = allocpkt();
				hdr_ip* ippkt = hdr_ip::access(next_pkt);
				ippkt->DSCP_=1;
				hdr_bbb* next_hdr      = hdr_bbb::access(next_pkt);
				next_hdr->answer       = NEGATIVE;
				next_hdr->type         = ANSWER;
				next_hdr->sender       = hdr->sender;
				next_hdr->endnode      = hdr->endnode;
				next_hdr->dscp         = cur_dscp;
				next_hdr->bndw_request =hdr->bndw_request;
				next_hdr->start_time   =hdr->start_time;
				next_hdr->stop_time    =hdr->stop_time;
				cur_dscp=cur_dscp+NEGATIVE;
				send(next_pkt,0);

			    /*update the list of Requests*/
			    Request newrequest(hdr->sender,hdr->endnode,hdr->bndw_request,hdr->start_time,hdr->stop_time);
		            newrequest.SetStatus(REJECTED);
		            list_request->add_to_list(newrequest);


			    available=TRUE;	/*the CentralBBbase is now availiable*/
			    break;/* get out of  while(1)*/

			   }/*end of "if( bbgnt_particip->agent_ask_bwd(n_agent,hop1,hdr->bndw_request)==1 )"*/

        	       }/*end of "else" */


                 }/*end of "while(1)" loop */

            }/*end of "if (hdr->hop_num==1)"*/
	   }/*end of if the request is valid*/

	   /*************************************
	    ELSE Negative answer to the sender
	   /*************************************/
	   else
	   {
	   	cout<<"sorry the time of the request is invalid"<<"\n";
	        /****************************
		 send negative answer to
		 the request sender
		*****************************/
		dst_.addr_ = hdr->sender;/*set the destination address of the packet*/
		/****************************
         	 allocate & send a new packet
	        *****************************/
		Packet* next_pkt = allocpkt();
		hdr_ip* ippkt = hdr_ip::access(next_pkt);
		ippkt->DSCP_=1;
		hdr_bbb* next_hdr      = hdr_bbb::access(next_pkt);
		next_hdr->answer       = NEGATIVE;
		next_hdr->type         = ANSWER;
		next_hdr->sender       = hdr->sender;
		next_hdr->endnode      = hdr->endnode;
		next_hdr->dscp         = cur_dscp;
		next_hdr->bndw_request =hdr->bndw_request;
		next_hdr->start_time   =hdr->start_time;
		next_hdr->stop_time    =hdr->stop_time;
		cur_dscp=cur_dscp+0;
		send(next_pkt,0);


		Request newrequest(hdr->sender,hdr->endnode,hdr->bndw_request,hdr->start_time,hdr->stop_time);
		newrequest.SetStatus(REJECTED);
		list_request->add_to_list(newrequest);/*create a new record to request database*/
           }


        }/*end of "else" */

    }/*end of packet handling ,packet_type==REQUEST*/



    /******************************************
     if the type of the packet is CENTR_ANSWER
    *******************************************/
    /******************************************
     this packet is an inform packet
      for the condition of a node.
     A BBedge agent send it  to the
     CentralBBbase either because BBedge is now
     up or because BBedge Agent answers to a
     question of the CentralBBbase
    *******************************************/
    /******************************************
     answer from a node. enter the
     information to the list(database)
    ******************************************/
    else if(hdr->type == CENTR_ANSWER)
    {
       PacketData* data_;
        data_=pkt->userneighdata();/*pass the data of the packet into a AppData instance*/

       /*rebuilding the list*/
       list<neighbour> nnghbr_list;

       int i=0;
       int j=0;
       int size=pkt->dataneighlen();/*data magnitude*/
       int* data;
       data=data_->neighdata();
       /*cout<<"the magnitude of data is "<< size <<"\n"; */
       int nsize=size/2;
       for(j=0;j!=nsize;j++)
       {
            int x;
            int y;

            x=data[i];
	    cout<<"n_id is "<< x <<"\n";
	    i=i+1;
            y=data[i];
	    cout<<"bwdth is "<< y <<"\n";
	    i=i+1;
            neighbour neighb(x,y,data_->start_time(),data_->stop_time());
            nnghbr_list.push_back(neighb);

       }

       /*create an object of BBagent in order to make update of the list, the particular BBagent*/
       BBagent n_agent(hdrip->saddr(),nnghbr_list,hdr->status);/*function saddr() does this:*/
	    				    /*nsaddr_t& saddr() { return (src_.addr_); }*/
	                                    /*returning the address of the sender of the packet*/


	/*add the new information about BBagent into the list , with the function update list*/
       bbgnt_particip->update_list(n_agent);
	/*cout<<"end of packet_type==CENTR_ANSWER \n";*/

    }/*end of packet handling ,packet_type==CENTR_ANSWER*/

    Packet::free(pkt);
}/*end of function "recv"*/


