/***************************************************************************
  Research Academic Computer Technology Institute,
  61 Riga Feraiou Str,26221 Patras ,Greece &
  Department of Computer Engineering and Informatics,
  University of Patras, 26500 Rion ,Patras,Greece

  Research Unit 6

  project name:Bandwidth Broker
  project team:Christos Bouras
               Dimitris Primpas
	       Kostas Stamos
	       Ioannis Pappas

  date:20 January 2005
  updated:no
  contact:bouras@cti.gr,primpas@cti.gr,stamos@cti.gr,pappasj@ceid.upatras.gr

*****************************************************************************/

/* Headers */
#include "List_Requests.h"
#include <iostream.h>


/*constants*/
/*******************************************
 constants name:PENDING,SATISFIED,
 		REJECTED,EXPIRED
mission:these constants specify the
	status in which a request is
*******************************************/
#define PENDING     0
#define SATISFIED   1
#define REJECTED    2
#define EXPIRED     3


/* constructor */
List_Requests::List_Requests()
{
 size_of_list=0;
}



/* access functions */
int List_Requests::GetSize_of_list() const
{ return size_of_list; }

void List_Requests::SetSize_of_list(int nsize_of_list)
{ size_of_list=nsize_of_list; }


/*list control functions */

/******************************************************************
 function name: List_Requests::add_to_list
 return value:void
 arguments:a Request object
 mission:adds the Request object demand to the list of Request objects.
 	 If the instance of demand already exists ,we remove it and
	 we add the new one with the most recent information,
	  else we add the new one immediately and we increase the
	  variable size_of_the_list by one.
*******************************************************************/
void List_Requests::add_to_list(Request& demand)
{
  /*first we make a copy of the Request object demand */
  Request instance = demand;

  /* then we set the status of the copy(named:instance) as PENDING */
  /* the reason is that the function add_to_list is used both for updating
     and adding a new request to list*/
  instance.SetStatus(PENDING);
  list<Request>::iterator rqst_list_iter;/* an iterator for rqst_list */

  /*find in the list the Request object demand */
  rqst_list_iter = find(rqst_list.begin(), rqst_list.end() , instance);

  /*if demand already exists, erase the old information and add the new one*/
  /*situation updating the list*/
  if(rqst_list_iter != rqst_list.end())
  {
   rqst_list.erase(rqst_list_iter);
   rqst_list.push_back(demand);
  }

  /*else add the new demand to the list */
  /*situation adding a new request to the list*/
  else
  {
   rqst_list.push_back(demand);
   size_of_list=size_of_list+1;
  }

}


/********************************************************
function name: List_Requests::get_cur_rqst
return value:object of the class Request
arguments:none
mission:returns the Request object which is added last
	 into the list
*********************************************************/
Request List_Requests::get_cur_rqst()
{
 return rqst_list.back();
}


/********************************************************
function name: List_Requests::get_first_rqst
return value:object of the class Request
arguments:none
mission:returns the Request object which is now first
        into the list
*********************************************************/
Request List_Requests::get_first_rqst()
{
 return rqst_list.front();
}


/******************************************************************
 function name: List_Requests::remove_from_list
 return value:void
 arguments:a Request object
 mission:remove a Request from the list of Request objects
*******************************************************************/
void List_Requests::remove_from_list(Request& demand)
{

  list<Request>::iterator rqst_list_iter;/* an iterator for rqst_list */

  /*find in the list the Request object demand */
  rqst_list_iter = find(rqst_list.begin(), rqst_list.end() , demand);

  rqst_list.erase(rqst_list_iter);/*erase him from the list*/
  size_of_list=size_of_list-1;/* reduce by one(1) the size of list */

}