/***************************************************************************
  Research Academic Computer Technology Institute,
  61 Riga Feraiou Str,26221 Patras ,Greece &
  Department of Computer Engineering and Informatics,
  University of Patras, 26500 Rion ,Patras,Greece

  Research Unit 6

  project name:Bandwidth Broker
  project team:Christos Bouras
               Dimitris Primpas
	       Kostas Stamos
	       Ioannis Pappas

  date:20 January 2005
  updated:no
  contact:bouras@cti.gr,primpas@cti.gr,stamos@cti.gr,pappasj@ceid.upatras.gr

*****************************************************************************/

/*Headers */
#include "Request.h"
#include <iostream.h>


/*constants*/
/*******************************************
 constants name:PENDING,SATISFIED,
 		REJECTED,EXPIRED
mission:these constants specify the
	status in which a request is
*******************************************/
#define PENDING     0
#define SATISFIED   1
#define REJECTED    2
#define EXPIRED     3


/*constructor*/
Request::Request(nsaddr_t nsender,nsaddr_t nendnode,int nbndw_request,double nstart_time,double nstop_time):
	sender(nsender),endnode(nendnode),bndw_request(nbndw_request),start_time(nstart_time),stop_time(nstop_time),status(PENDING)
        {
         /* cout << "request constructor "<<endl;*/
        }



/*operators overloading*/
Request& Request::operator=(const Request &rqst)
{
   this->sender = rqst.sender;
   this->endnode = rqst.endnode;
   this->bndw_request = rqst.bndw_request;
   this->start_time = rqst.start_time;
   this->stop_time = rqst.stop_time;
   this->status = rqst.status;

   return *this;
}

int Request::operator==(const Request &rqst) const
{
  if(this->sender != rqst.sender ) return 0;
  if( this->endnode != rqst.endnode  ) return 0;
  if(this->bndw_request != rqst.bndw_request ) return 0;
  if( this->start_time != rqst.start_time  ) return 0;
  if( this->stop_time != rqst.stop_time  ) return 0;
  if( this->status != rqst.status  ) return 0;
  return 1;
}


      /*access functions*/
nsaddr_t Request::GetSender() const
{ return sender; }

void Request::SetSender(nsaddr_t nsender)
{ sender=nsender;  }

nsaddr_t Request::GetEndnode() const
{ return endnode; }

void Request::SetEndnode(nsaddr_t nendnode)
{ endnode=nendnode; }

int Request::GetBndw_request() const
{ return bndw_request; }

void Request::SetBndw_request(int nbndw_request)
{ bndw_request=nbndw_request; }

double Request::GetStart_time() const
{ return start_time; }

void Request::SetStart_time(double nstart_time)
{ start_time=nstart_time; }

double Request::GetStop_time() const
{ return stop_time; }

void Request::SetStop_time(double nstop_time)
{ stop_time=nstop_time;}

int Request::GetStatus() const
{ return status; }

void Request::SetStatus(int nstatus)
{ status=nstatus; }


/*************************************************
function name: Request::ShowRequest
return value:void
arguments:none
mission:shows all the elements of a request
**************************************************/
void Request::ShowRequest()
{
 cout<<"sender is "<< sender <<endl;
 cout<<"endnode is "<< endnode  <<endl;
 cout<<"bndw_request is "<< bndw_request <<endl;
 cout<<"start_time is "<< start_time <<endl;
 cout<<"stop_time is "<< stop_time <<endl;
 cout<<"status is  "<< status <<endl;


}
